\subsection{Each trade is done in parallel}
As suggested in the original paper, all trades can be done in parallel for the directed and bipartite graphs. This is not possible, or at least not in a straightforward way, for the undirected graphs.

\begin{verbatim}
For each pair of nodes chosen UAR: (u,v), do in parallel:
  new_neighbors_u, new_neighbors_v := TRADE(u,v)
new_adjacency_map := COLLECT(new_neighbors)
\end{verbatim}



\subsubsection{Implementation Using threads (or subprocesses)}
\begin{verbatim}
                         Single Trade

                       +--> Thread 1 --+
                       |      ...      |
  CHOOSE UAR 2 NODES --+--> Thread i --+--> COLLECT ALL ADJACENCY MAP LINES
                       |      ...      |
                       +--> Thread n --+
\end{verbatim}

\paragraph{TODO: measuring efficiency}
\begin{itemize}
  \item Influence of number of threads (or processes) vs size of the dataset
  \item is MPI better?
  \item sanity check: time increases linearly with number of steps (done)
\end{itemize}

\begin{figure}
  \includegraphics[scale=0.5]{img/time_vs_steps_trades_as_subprocess_default_dataset.png}
  \caption{Computation time required when trades are done in parallel by subprocesses. The dataset is the default one (8 nodes)}
  \label{fig.time.steps.subpr.default}
\end{figure}


\subsection{When the adjacency map does not fit into memory}
\paragraph{Idea}
Slice the adjacency map.

Let $n$ parallel processes compute each one curveball step on a slice of the adjacency map. Then concatenate the resulting (sliced) adjacency maps all together.

\paragraph{Problem}
The Curveball algorithms implies to pick UAR two nodes. So one cannot slice the adjacency map in order (1-10, 11-20, ...).

\paragraph{Solution}
For each line of the adjacency map, pick a process UAR and send that line to this specific process.
Each parallel process has a slice of the adjacency map where the lines are sampled UAR from the total adjacency map (e.g., slice 1: 1,15,56,890; slice 2: 4,78,345,789; ...).

Let each parallel process compute one step of the curveball. Then collect all the sliced adjacency map into the new one (graph $G_{n+1}$).


\begin{verbatim}
                                Curveball  Step
                          done by each parallel process

                                +--> Core 1 --+
                                +     ...     +
Adj_map ---> Random Core Picker +--> Core i --+--> Stream To Coocc(x,y) -->
                    ^           +     ...     +    (or save to file)    -->
                    |           +--> Core n --+            |
                    |                                      |
                    +--------------------------------------+
\end{verbatim}


One can stream some part of the adjacency map to cooccurence computation to compute coocc between specific nodes (and not the entire coocc, we'll do that later but we need to save the full adjacency map somewhere)


\paragraph{Naive version}
Program in charge of dispatching the adjacency map:
\begin{itemize}
  \item Read file (or adjacency map) line by line
  \item For each line, choose UAR a core, send the line to that core.
  \item Wait until all cores have performed their computation (curveball on local adjacency map)
  \item Get all new adjacency map line by line from all cores.
  \item Either GOTO 1 or SAVE to file
\end{itemize}

Core (program executing the curveball algo on a subset of the adjacency map)
\begin{itemize}
  \item Get all lines (\textbf{Find a way to know where no more lines will come})
  \item Concat all lines in a local adjacency matrix
  \item Compute one step of the curveball
  \item Either send the new local adjacency matrix back (line by line, streaming) OR save to file
\end{itemize}

\begin{verbatim}
1:x,x,x...        | 2: x,x,x,...
2:x,x,x...        | 5: x,x,x,...
3:x,x,x...        | 17:x,x,x...
4:x,x,x...
5:x,x,x...        | 1: x,x,x,...
..........        | 56:x,x,x,...
n:x,x,x...        | n: x,x,x,...

 ADJ MAP              SLICES
\end{verbatim}

\paragraph{Problem when a slice contains an odd number of nodes:neighbors}
We are losing a trade. Let $S_i$ be a given slice ($i\in[1,s]$, $s$ being the number of slices). Let $|V|$ the total number of nodes ($\sum_{i}|S_i| = |V|$). If $|S_i|$ is odd, then one node will not trade its neighbors. If $|S_i|$ and $|S_j|$ are odds, then one trade is lost. More generally if $x$ slices have an odd cardinality then we lose $x/2$ trades. Conclusion, one should avoid having slices with odd number of elements.

\paragraph{Solution}
Use a counter for each slice to know if the number of element is odd. When reaching the last $s$ lines of the adjacency maps, check which slice has an odd number of elements and need one more. Arrange the last $s$ lines among the slices in need for a new element.

\paragraph{Other solution (lazy)} If $s$ is small (compared to $|V|/2$ the total number of trades), do not worry about losing trades.
